import {checkValidationDefination} from "./GenrateStoreObj"
import {ENTITY,ENTITY_COLUMN,CONSTANT_DEFINATION,REQUEST_METHOD} from "./const"

function fetchQuery(url,method,header,data:any=null){
    return new Promise((resolve,reject)=>{
     let fetchData={
        method:method,
        headers:header
      }
      if(data){
        fetchData["body"]=JSON.stringify(data)
      }
      fetch(url,fetchData)
      .then((res)=>res.json())
      .then((result)=>{
        resolve(result)
      })
      .catch((err)=>{
        reject(err)
      })
    })
}



export default class Curd<T>{
    private url:string;
    private path:string;
    private header:object;
    constructor(url:string,path:string,header:object){
        this.url=url;
        this.path=path;
        this.header=header;
    }
    add(entity:T):Promise<any>{
       let x=checkValidationDefination(entity[ENTITY.DEFINATION],entity);
       if(x.error){
        return Promise.reject(x)
       }
       else{
        return fetchQuery(this.url+this.path,REQUEST_METHOD.POST,this.header,x.data);
       }          
    }
    update(entity:T):Promise<any>{
      let x=checkValidationDefination(entity[ENTITY.DEFINATION],entity);
      if(x.error){
       return Promise.reject(x)
      }
      else{
       return fetchQuery(this.url+this.path,REQUEST_METHOD.PUT,this.header,x.data);
      }
    }
    delete(entity:T):Promise<any>{
      let x=checkValidationDefination(entity[ENTITY.DEFINATION],entity);
      if(x.error){
       return Promise.reject(x)
      }
      else{
       return fetchQuery(this.url+this.path,REQUEST_METHOD.DELETE,this.header,x.data);
      }
    }
    getAll():Promise<any>{
       return fetchQuery(this.url+this.path,REQUEST_METHOD.GET,this.header);
    }
    getById(id:number|string):Promise<any>{
      return fetchQuery(this.url+this.path+"/"+id,REQUEST_METHOD.GET,this.header);
    }
   
    getCall(path):Promise<any>{
       return fetchQuery(this.url+path,REQUEST_METHOD.GET,this.header)
    }
    postCall(path,data){
      return fetchQuery(this.url+path,REQUEST_METHOD.POST,this.header)
    }
    putCall(path,data){
      return fetchQuery(this.url+path,REQUEST_METHOD.PUT,this.header)
    }
    deleteCall(path,data){
      return fetchQuery(this.url+path,REQUEST_METHOD.PUT,this.header)
    }
    fetchCall=fetchQuery;
}